#include <stdio.h>


#define RC5_DEVICE_CODE 0x07  // experimental
#define RC5_TEMPLATE (0x3000 | (RC5_DEVICE_CODE << 6))
#define CMD 0x11
#define RC5_CMD RC5_TEMPLATE | (CMD & 0x3f)


// modulation square wave generation
// compare output mode: toggle OC0A on compare match
// if COM0Ax are all unset, the waveform generation is disabled and
// the normal PORTx value is seen on the OC0A pin.
#define ENABLE_MODULATION printf("1")
#define DISABLE_MODULATION printf("0")

// activate bit timer
#define ENABLE_BIT_TIMER (TCCR1B |= _BV(CS10))
#define DISABLE_BIT_TIMER printf("bit timer: off\n")

// button control
// MCUCR is setup by default to trigger INT0 on low level
#define ENABLE_BUTTONS (GIMSK |= _BV(INT0))
#define DISABLE_BUTTONS (GIMSK &= ~_BV(INT0))



unsigned int rc5data = RC5_CMD;
unsigned char bitcounter = 0;
unsigned char halfbitcounter = 0;



void timer(void) {
  unsigned char bit = ((rc5data & 0x2000) >> 13);
  unsigned char half = (bit ^ ((halfbitcounter == 0) ? 1 : 0));

  if(half && bitcounter < 14) {
    ENABLE_MODULATION;
  } else {
    DISABLE_MODULATION;
  }

  if(bitcounter >= 64) {
    DISABLE_BIT_TIMER;
    //ENABLE_BUTTONS;
  } else if(bitcounter == 14) {
    DISABLE_MODULATION;
  }

  if(halfbitcounter == 0) {
    halfbitcounter++;
  } else {
    halfbitcounter = 0;
    bitcounter++;
    rc5data *= 2; // shift left rc5 data
  }
  printf(".");
}


int main(void) {
  int i;
  for( i = 0; i < 65; ++i) {
    //printf("step %i: ", i);
    timer();

  }
}